execute as @e[type=iron_golem,tag=deepslate_titan] at @s as @a[distance=..20,limit=1,sort=arbitrary,gamemode=!creative,gamemode=!spectator] run data modify entity @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] AngryAt set from entity @s UUID

##Summon in structure
execute as @e[type=armor_stand,tag=dtitan_spawner] at @s run function deepslate_titan:deepslate_titan/summon_asleep

execute as @a[nbt={SelectedItem:{components:{"minecraft:custom_data":{earth_heart:1b}}}},scores={deept.item=1..}] at @s positioned ~ ~1.2 ~ if block ^ ^ ^0.5 #air if block ^ ^ ^1 #air if block ^ ^ ^1.5 #air if block ^ ^ ^2 #air positioned ^ ^ ^3 if entity @e[type=iron_golem,tag=deepslate_titan,tag=asleep,tag=!waking,distance=..2.5] run tag @s add waker
execute as @a[tag=waker] at @s positioned ~ ~1.2 ~ positioned ^ ^ ^3 run tag @e[type=iron_golem,tag=deepslate_titan,tag=asleep,tag=!waking,distance=..2.5,limit=1] add waking
execute as @a[tag=waker] at @s run item replace entity @s weapon.mainhand with air
tag @a[tag=waker] remove waker

function deepslate_titan:deepslate_titan/summon_animation

## Display

execute as @e[type=iron_golem,tag=deepslate_titan] at @s run teleport @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] ~ ~ ~
execute as @e[type=item_display,tag=aj.deepslate_titan.root] unless score @s deept.death_time matches 0.. run scoreboard players set @s deept.death_time 0
execute as @e[type=item_display,tag=aj.deepslate_titan.root] at @s unless entity @e[type=iron_golem,tag=deepslate_titan,distance=..5] run scoreboard players add @s deept.death_time 1
execute as @e[type=item_display,tag=aj.deepslate_titan.root] at @s unless entity @e[type=iron_golem,tag=deepslate_titan,distance=..5] run function deepslate_titan:deepslate_titan/death

#fix rotation

execute as @e[type=iron_golem,tag=deepslate_titan] store result score @s deept.rotationx run data get entity @s Rotation[0]
execute as @e[type=item_display,tag=aj.deepslate_titan.root] store result score @s deept.rotationx run data get entity @s Rotation[0]

execute as @e[type=item_display,tag=aj.deepslate_titan.root] at @s run scoreboard players operation @s deept.rotationx -= @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] deept.rotationx
scoreboard players remove @e[type=item_display,tag=aj.deepslate_titan.root,scores={deept.rotationx=180..}] deept.rotationx 360
scoreboard players add @e[type=item_display,tag=aj.deepslate_titan.root,scores={deept.rotationx=..-181}] deept.rotationx 360


execute as @e[type=item_display,tag=aj.deepslate_titan.root] at @s if entity @e[distance=..5,type=iron_golem,tag=deepslate_titan] if score @s deept.rotationx matches 5..180 run teleport @s ~ ~ ~ ~-5 0
execute as @e[type=item_display,tag=aj.deepslate_titan.root] at @s if entity @e[distance=..5,type=iron_golem,tag=deepslate_titan] if score @s deept.rotationx matches -180..-5 run teleport @s ~ ~ ~ ~5 0


##Motion
scoreboard players add @e[type=iron_golem,tag=deepslate_titan,nbt=!{Motion:[0d,0d,0d]}] deept.sound_time 1
execute as @e[type=iron_golem,tag=deepslate_titan,nbt=!{Motion:[0d,0d,0d]},tag=!punching,tag=!spinning,tag=!jumping,tag=!throwing,tag=!spiking,scores={deept.sound_time=40..}] at @s run playsound minecraft:deepslate_titan.walk hostile @a[distance=..25] ~ ~ ~
scoreboard players set @e[type=iron_golem,tag=deepslate_titan,nbt=!{Motion:[0d,0d,0d]},scores={deept.sound_time=40..}] deept.sound_time 0

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!moving,nbt=!{Motion:[0d,0d,0d]},tag=!punching,tag=!spinning,tag=!jumping,tag=!throwing,tag=!spiking] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}
tag @e[type=iron_golem,tag=deepslate_titan,tag=!moving,nbt=!{Motion:[0d,0d,0d]}] add moving

execute as @e[type=iron_golem,tag=deepslate_titan,tag=moving,nbt={Motion:[0d,0d,0d]},tag=!punching,tag=!spinning,tag=!jumping,tag=!throwing,tag=!spiking] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/stand/tween {to_frame: 0, duration: 1}
tag @e[type=iron_golem,tag=deepslate_titan,tag=moving,nbt={Motion:[0d,0d,0d]}] remove moving

#Hurt
execute as @e[type=iron_golem,tag=deepslate_titan,nbt=!{HurtTime:0s},tag=!asleep,tag=!hurt] at @s run playsound minecraft:deepslate_titan.hurt hostile @a[distance=..25] ~ ~ ~ 1
execute as @e[type=iron_golem,tag=deepslate_titan,nbt=!{HurtTime:0s},tag=!asleep,tag=!hurt] run tag @s add hurt

execute as @e[type=iron_golem,tag=deepslate_titan,nbt=!{HurtTime:0s},tag=!asleep] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/variants/hurt/apply
execute as @e[type=iron_golem,tag=deepslate_titan,nbt={HurtTime:0s},tag=!asleep] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/variants/default/apply

execute as @e[type=iron_golem,tag=deepslate_titan,nbt={HurtTime:0s},tag=!asleep] run tag @s remove hurt

##Punch

execute as @e[type=iron_golem,tag=deepslate_titan] store result score @s deept.angry run data get entity @s AngryAt[0]


execute as @e[type=iron_golem,tag=deepslate_titan,tag=!punching,tag=!spinning,tag=!jumping,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=..5] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/punch/tween {to_frame: 0, duration: 1}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=..5] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run tag @e[tag=deepslate_titan,limit=1,sort=nearest] add punching
execute as @e[type=iron_golem,tag=deepslate_titan,tag=punching] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0}

scoreboard players add @e[type=iron_golem,tag=deepslate_titan,tag=punching] deept.power1_time 1

execute as @e[type=iron_golem,tag=deepslate_titan,tag=punching,scores={deept.power1_time=15}] at @s positioned ~ ~3.5 ~ as @e[distance=..5,type=!#deepslate_titan:not_mob] if score @s deept.uuid = @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] deept.angry run damage @s 21 mob_attack by @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] from @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest]

tag @e[type=iron_golem,tag=deepslate_titan,tag=punching,scores={deept.power1_time=30..}] add moving
execute as @e[type=iron_golem,tag=deepslate_titan,tag=punching,scores={deept.power1_time=30..}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}

tag @e[type=iron_golem,tag=deepslate_titan,tag=punching,scores={deept.power1_time=30..}] remove punching
scoreboard players set @e[type=iron_golem,tag=deepslate_titan,scores={deept.power1_time=30..}] deept.power1_time 0

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!punching,tag=!spinning,tag=!jumping] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0.25}

## Choose attack
execute as @e[type=iron_golem,tag=deepslate_titan] unless score @s deept.power2_time matches 200.. run scoreboard players add @s deept.power2_time 1

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=200}] store result score @s deept.random run random value 0..1

#scoreboard players set @e[type=iron_golem,tag=deepslate_titan] deept.random 1


## Spin

scoreboard players add @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=200..},tag=spinning] deept.power2_time 1

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,scores={deept.power2_time=200,deept.random=0},tag=!punching,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=..6] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run playsound deepslate_titan.assembly hostile @a[distance=..25]
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,scores={deept.power2_time=200,deept.random=0},tag=!punching,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=..6] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run tag @e[tag=deepslate_titan,limit=1,sort=nearest] add spinning

execute as @e[type=iron_golem,tag=deepslate_titan,tag=spinning] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0}


execute as @e[type=iron_golem,tag=deepslate_titan,tag=spinning,scores={deept.power2_time=200}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/spin/tween {to_frame: 0, duration: 1}

execute as @e[type=iron_golem,tag=deepslate_titan,tag=spinning,scores={deept.power2_time=210..}] at @s positioned ~ ~3.5 ~ as @e[distance=..6,type=!#deepslate_titan:not_mob,tag=!deepslate_titan,tag=!deepslate_golem,type=!item] run damage @s 21 mob_attack by @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] from @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest]

tag @e[type=iron_golem,tag=deepslate_titan,tag=spinning,scores={deept.power2_time=260..}] add moving
execute as @e[type=iron_golem,tag=deepslate_titan,tag=spinning,scores={deept.power2_time=260..}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}

tag @e[type=iron_golem,tag=deepslate_titan,tag=jumping,scores={deept.power2_time=260..}] add moving
execute as @e[type=iron_golem,tag=deepslate_titan,tag=jumping,scores={deept.power2_time=260..}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}


tag @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=260..}] remove spinning
tag @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=260..}] remove jumping

scoreboard players set @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=260..},tag=!throwing,tag=!spiking] deept.power2_time 0

## jump

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,tag=!asleep,scores={deept.power2_time=200,deept.random=1},tag=!punching,tag=!throwing,tag=!spiking] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=..10] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run tag @e[tag=deepslate_titan,limit=1,sort=nearest] add jumping
scoreboard players add @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=200..},tag=jumping] deept.power2_time 1


execute as @e[type=iron_golem,tag=deepslate_titan,tag=jumping,scores={deept.power2_time=200..235}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=jumping,scores={deept.power2_time=250..}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0.25}

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=201},tag=jumping] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/jump/tween {to_frame: 0, duration: 1}
effect give @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=245},tag=jumping] levitation 1 19 true
execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=245},tag=jumping] at @s run playsound minecraft:entity.wind_charge.wind_burst hostile @a[distance=..25] ~ ~ ~

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=259..},tag=jumping] run tag @s add has_jumped
execute as @e[type=iron_golem,tag=deepslate_titan,tag=has_jumped] at @s unless block ~ ~-1 ~ #minecraft:air run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=iron_golem,tag=deepslate_titan,tag=has_jumped] at @s unless block ~ ~-1 ~ #minecraft:air run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ 6 .1 6 .1 600 force
execute as @e[type=iron_golem,tag=deepslate_titan,tag=has_jumped] at @s unless block ~ ~-1 ~ #minecraft:air as @e[distance=..10,type=!#deepslate_titan:not_mob,tag=!deepslate_titan,type=!item,tag=!deepslate_golem] run damage @s 45 mob_attack by @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest] from @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest]

execute as @e[type=iron_golem,tag=deepslate_titan,tag=has_jumped] at @s unless block ~ ~-1 ~ #minecraft:air run tag @s remove has_jumped


## throw
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,scores={deept.power2_time=200,deept.random=0},tag=!punching,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=11..30] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run tag @e[tag=deepslate_titan,limit=1,sort=nearest] add throwing
scoreboard players add @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=200..},tag=throwing] deept.power2_time 1

execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=200..299}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=300..}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0.25}

execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=200..299}] at @s as @e[tag=!deepslate_titan,distance=..80] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry facing entity @s feet run teleport @e[tag=deepslate_titan,limit=1,sort=nearest] ~ ~ ~ ~ 0 

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=201},tag=throwing] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/throw/tween {to_frame: 0, duration: 1}

execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=280}] at @s run summon armor_stand ^ ^4 ^4.5 {Small:1b,NoGravity:1b,Invulnerable:1b,Invisible:1b,Tags:["boulder"],DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:stick",count:1,components:{"minecraft:item_model":"deepslate_titan:boulder"}}]}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=280}] at @s as @e[tag=!deepslate_titan,distance=..80] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run teleport @e[type=armor_stand,tag=boulder,limit=1,sort=nearest] ^ ^4 ^4.5 facing entity @s eyes
execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=280}] at @s run playsound entity.wind_charge.wind_burst hostile @a[distance=..25] ~ ~ ~

scoreboard players add @e[type=armor_stand,tag=boulder] deept.age 1
kill @e[type=armor_stand,tag=boulder,scores={deept.age=60..}] 

execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ .3 .3 .3 .1 100 force
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run kill @s
execute as @e[type=armor_stand,tag=boulder] at @s run teleport @s ^ ^ ^0.5
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ .3 .3 .3 .1 100 force
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run kill @s
execute as @e[type=armor_stand,tag=boulder] at @s run teleport @s ^ ^ ^0.5
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ .3 .3 .3 .1 100 force
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=armor_stand,tag=boulder] at @s unless block ^ ^ ^0.5 #air run kill @s
execute as @e[type=armor_stand,tag=boulder] at @s run teleport @s ^ ^ ^0.5

execute as @e[type=armor_stand,tag=boulder] at @s as @e[tag=!deepslate_titan,tag=!boulder,type=!#deepslate_titan:not_mob,type=!item,type=!item_display,type=!arrow,type=!trident,distance=..2.5,limit=1] run playsound deepslate_titan.break hostile @a[distance=..10] ~ ~ ~
execute as @e[type=armor_stand,tag=boulder] at @s as @e[tag=!deepslate_titan,tag=!boulder,type=!#deepslate_titan:not_mob,type=!item,type=!item_display,type=!arrow,type=!trident,distance=..2.5,limit=1] run tag @s add boulder_damaged
execute as @e[tag=boulder_damaged] at @s run damage @s 30 mob_attack by @e[type=armor_stand,tag=boulder,limit=1,sort=nearest] from @e[type=iron_golem,tag=deepslate_titan,limit=1,sort=nearest]
execute as @e[tag=boulder_damaged] at @s run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ .3 .3 .3 .1 100 force
execute as @e[tag=boulder_damaged] at @s run kill @e[type=armor_stand,tag=boulder,limit=1,sort=nearest,distance=..3]


tag @e[tag=boulder_damaged] remove boulder_damaged

tag @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=300..}] add moving
execute as @e[type=iron_golem,tag=deepslate_titan,tag=throwing,scores={deept.power2_time=300..}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}

tag @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=300..}] remove throwing

scoreboard players set @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=300..},tag=!jumping,tag=!spinning,tag=!spiking] deept.power2_time 0

## Spike

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!spinning,tag=!jumping,scores={deept.power2_time=200,deept.random=1},tag=!punching,tag=!throwing,tag=!spiking,tag=!asleep] at @s positioned ~ ~3.5 ~ as @e[tag=!deepslate_titan,distance=11..30] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry run tag @e[tag=deepslate_titan,limit=1,sort=nearest] add spiking
scoreboard players add @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=200..},tag=spiking] deept.power2_time 1

execute as @e[type=iron_golem,tag=deepslate_titan,tag=spiking,scores={deept.power2_time=200..279}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=spiking,scores={deept.power2_time=280..}] run data modify entity @s attributes[4] merge value {id:"movement_speed",base:0.25}

execute as @e[type=iron_golem,tag=deepslate_titan,tag=spiking,scores={deept.power2_time=200..279}] at @s as @e[tag=!deepslate_titan,distance=..80] if score @s deept.uuid = @e[tag=deepslate_titan,limit=1,sort=nearest] deept.angry facing entity @s feet run teleport @e[tag=deepslate_titan,limit=1,sort=nearest] ~ ~ ~ ~ 0 

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=201},tag=spiking] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/spike/tween {to_frame: 0, duration: 1}

execute as @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=230},tag=spiking] at @s as @a[distance=..40,limit=4] at @s run summon armor_stand ~ ~ ~ {Tags:["spike_marker"],Invisible:1b,Invulnerable:1b,DisabledSlots:4144959}

scoreboard players add @e[type=armor_stand,tag=spike_marker] deept.age 1
execute as @e[type=armor_stand,tag=spike_marker] at @s run particle block{block_state:{Name:"deepslate"}} ^ ^ ^1.5 .05 .2 .05 0 5 force
execute as @e[type=armor_stand,tag=spike_marker] at @s run teleport @s ~ ~ ~ ~10 ~
execute as @e[type=armor_stand,tag=spike_marker] at @s run particle block{block_state:{Name:"deepslate"}} ^ ^ ^1.5 .05 .2 .05 0 5 force
execute as @e[type=armor_stand,tag=spike_marker] at @s run teleport @s ~ ~ ~ ~10 ~
execute as @e[type=armor_stand,tag=spike_marker,scores={deept.age=1}] run function deepslate_titan:seek_ground
execute as @e[type=armor_stand,tag=spike_marker,scores={deept.age=15}] at @s run function animated_java:deepslate_spike/summon {args:{animation: 'spike', start_animation: true}}
kill @e[type=armor_stand,tag=spike_marker,scores={deept.age=40..}]


tag @e[type=iron_golem,tag=deepslate_titan,tag=spiking,scores={deept.power2_time=280..}] add moving
execute as @e[type=iron_golem,tag=deepslate_titan,tag=spiking,scores={deept.power2_time=280..}] at @s as @e[type=item_display,tag=aj.deepslate_titan.root,limit=1,sort=nearest] run function animated_java:deepslate_titan/animations/walk/tween {to_frame: 0, duration: 1}

tag @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=280..}] remove spiking

scoreboard players set @e[type=iron_golem,tag=deepslate_titan,scores={deept.power2_time=280..},tag=!jumping,tag=!spinning,tag=!throwing] deept.power2_time 0

## Health Bar
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] at @s run bossbar add deepslate_titan {"color":"gray","text":"Deepslate Titan"}
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] run bossbar set minecraft:deepslate_titan style notched_10

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] run bossbar set deepslate_titan max 800
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] run bossbar set deepslate_titan color green
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] at @s run bossbar set deepslate_titan players @a[distance=..60]
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!asleep] store result bossbar deepslate_titan value run data get entity @s Health

## Summon Golems

execute as @e[type=iron_golem,tag=deepslate_titan] store result score @s deept.health run data get entity @s Health 1

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] at @s run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] at @s run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ 2 2 2 .1 500 force
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] at @s run particle smoke ~ ~ ~ 2 2 2 .1 500 force

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] at @s positioned ^-1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] at @s positioned ^1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
tag @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned,scores={deept.health=..600}] add has_summoned

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] at @s run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] at @s run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ 2 2 2 .1 500 force
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] at @s run particle smoke ~ ~ ~ 2 2 2 .1 500 force

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] at @s positioned ^-1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] at @s positioned ^1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
tag @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned2,scores={deept.health=..400}] add has_summoned2

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] at @s run playsound deepslate_titan.break hostile @a[distance=..25] ~ ~ ~
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] at @s run particle block{block_state:{Name:"deepslate"}} ~ ~ ~ 2 2 2 .1 500 force
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] at @s run particle smoke ~ ~ ~ 2 2 2 .1 500 force

execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] at @s positioned ^-1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
execute as @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] at @s positioned ^1 ^ ^ run function deepslate_titan:deepslate_golem/summon_deepslate_golem
tag @e[type=iron_golem,tag=deepslate_titan,tag=!has_summoned3,scores={deept.health=..200}] add has_summoned3